#include <p18cxxx.h>
#include <usart.h>
#include <delays.h>
//#include "system\typedefs.h"
//#include "system\usb\usb.h"
//#include "io_cfg.h"             // I/O pin mapping

#define	ENL LATCbits.LATC7
#define	RSL LATCbits.LATC6

void Ulcdt (unsigned char data);
void Ulcdc (unsigned char data);
void UinitLCD(void);


void UinitLCD(void)
{
//	TRISD=0x00;
//	PORTD=0xFF;
	DDRB=0;
	Delay10KTCYx(250);
	Delay10KTCYx(250);
	Delay10KTCYx(250);
	Delay10KTCYx(250);
	Delay10KTCYx(250);
	Delay10KTCYx(250);
	RSL=0;
	LATB=LATB|0x0C;
	LATB=LATB&0x0F;
	ENL=1;
	_asm
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(100); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(20); // Delay of 15ms		
	ENL=1;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(20); // Delay of 15ms		
	LATB=LATB&0x03;
	LATB=LATB|0x08;
	ENL=1;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(100); // Delay of 15ms		
	lcdc(0x28);		//!!!2lines!!!, 4bit,5*7font
	lcdc(0x0C);		//disp on,blink & cursor off
	lcdc(0x01);		//erase disp, cursor home
}


void Ulcdc (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=0;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	LATB=(LATB|datat);
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	RSL=0;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	LATB=(LATB|(data&0x3F));
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(40);
}


void Ulcdt (unsigned char data)
{
	unsigned char datat;
	datat=data;
	RSL=1;
	ENL=1;
	datat>>=4;
	datat=datat&0x0F;
	datat<<=2;
	LATB=LATB&0x03;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	LATB=(LATB|datat);
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	RSL=1;
	ENL=1;
	data<<=2;
	LATB=LATB&0x03;
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	LATB=(LATB|(data&0x3F));
	_asm
	nop
	nop
	nop
	nop
	nop
	_endasm
	ENL=0;
	Delay1KTCYx(40);
}
