// PICConnector.h: interface for the PICConnector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PICCONNECTOR_H__518E24BC_B80D_4227_A2E5_F55660FCD5CB__INCLUDED_)
#define AFX_PICCONNECTOR_H__518E24BC_B80D_4227_A2E5_F55660FCD5CB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
This code is copied from the 
  C:\MCHPFSUSB\Pc\Mpusbapi\Example Applications\Borland_C\Example 02 - Run-time Linking
application.

*/


class PICConnector  
{
	HINSTANCE libHandle;
	HANDLE myOutPipe;
	HANDLE myInPipe;

public:
	void LoadDLL();
	void Close();
	char Open();
	PICConnector();
	DWORD SendReceivePacket(BYTE *SendData, DWORD SendLength, BYTE *ReceiveData,
                    DWORD *ReceiveLength, UINT SendDelay, UINT ReceiveDelay);
	void CheckInvalidHandle(void);


	virtual ~PICConnector();


};

#endif // !defined(AFX_PICCONNECTOR_H__518E24BC_B80D_4227_A2E5_F55660FCD5CB__INCLUDED_)
