// loggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "logger.h"
#include "loggerDlg.h"

#include "fstream.h"
#include "conio.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoggerDlg dialog

CLoggerDlg::CLoggerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoggerDlg)
	m_edit = _T("");
	m_subor = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLoggerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoggerDlg)
	DDX_Text(pDX, IDC_EDIT1, m_edit);
	DDX_Text(pDX, IDC_EDIT2, m_subor);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLoggerDlg, CDialog)
	//{{AFX_MSG_MAP(CLoggerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnRequest)
	ON_BN_CLICKED(IDC_BUTTON2, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON3, OnClose)
	ON_EN_CHANGE(IDC_EDIT2, OnSuborVstup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoggerDlg message handlers

BOOL CLoggerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_subor = "subor.txt";
	UpdateData(FALSE);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLoggerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLoggerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLoggerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLoggerDlg::OnRequest() 
{
BYTE send_buf[64],receive_buf[64];
    DWORD RecvLength=32;
	BYTE stopflag;
	UpdateData(TRUE);	
    #define MOJ_REKVEST    0x40
	//////////////
	char count;
	char buffer[30];
	fstream file;
	file.open(m_subor,ios::app);
	sprintf(buffer,"-----start-----\n");
	cin>>buffer;
	file<<buffer;
	//////////////
	stopflag=1;
	int adresa=0;
	int adresaH=0;
    while ((adresaH<32)&(stopflag))
	{	
		send_buf[0] = MOJ_REKVEST;      // Command
		send_buf[1] = adresa;
	    send_buf[2] = adresaH;

		if(	m_PICConnector.SendReceivePacket(send_buf,3,receive_buf,&RecvLength,80,80) == 1)
			{
			if(RecvLength == 32)
				{
//				if (receive_buf[1]==64) stopflag=0;

				for (count=0;count<32;count=count+4)
					{
					if ((receive_buf[count]==255)&(receive_buf[count+1]==255)&(receive_buf[count+2]==255)&(receive_buf[count+3]==255)) 
						{						
						stopflag=0;
						break;
						}
					else {
							sprintf(buffer,"%d %i %d\n",receive_buf[count],(receive_buf[count+1]+(receive_buf[count+2]*256)),((receive_buf[count+3])/2));
							cin>>buffer;
							file<<buffer;
						}
					}
				adresa=adresa+32;
				if (adresa>255)
					{
					adresa=0;
					adresaH++;
					}
				}
			else 
				{
				AfxMessageBox("Zla odpoved.");
				break;
				}
			}	
		else 
		{
			AfxMessageBox("Zla odpoved!");
			break;
		}
	}
	sprintf(buffer,"------end------\n");
	cin>>buffer;
	file<<buffer;
	file.close();
    m_edit.Format("%i bytov precitanych", adresa+(adresaH*256));
	UpdateData(FALSE);

	
}

void CLoggerDlg::OnOpen() 
{
	
	if (m_PICConnector.Open()) m_edit.Format("OK");
	UpdateData(FALSE);
}

void CLoggerDlg::OnClose() 
{
	m_PICConnector.Close();		
	m_edit.Format("--");
	UpdateData(FALSE);
}

void CLoggerDlg::OnSuborVstup() 
{
	UpdateData(TRUE);
}
