//Global variables 

extern unsigned int PageSize;

//Function Prototypes

void InitPIC(void);         // Initializes the PIC to POR defaults
unsigned char PutStringSPI( unsigned char * );
void SPIWIPPolling(void);
void WriteEnable(void);
void ReadStatus(void);

unsigned char LDByteWriteSPI ( unsigned char, unsigned char);
unsigned char LDByteReadSPI (unsigned char, unsigned char * , unsigned char);
unsigned char LDPageWriteSPI (unsigned char, unsigned char *);
unsigned char LDSequentialReadSPI (unsigned char, unsigned char *, unsigned char );

unsigned char HDByteWriteSPI(unsigned char, unsigned char, unsigned char );
unsigned char HDByteReadSPI(unsigned char, unsigned char, unsigned char * , unsigned char );
unsigned char HDPageWriteSPI( unsigned char, unsigned char, unsigned char * );
unsigned char HDSequentialReadSPI( unsigned char, unsigned char, unsigned char *, unsigned char );

//********************************************************************
//Constant Definitions
//********************************************************************


#define CS PORTAbits.RA1    // CS for SPI

